/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: ...
   co-programmer: ...
*/

//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_

#include "glgui_energywidget.h"

namespace OrxGui
{
  /**
   * @brief standard constructor
   * @todo this constructor is not jet implemented - do it
  */
  GLGuiEnergyWidget::GLGuiEnergyWidget ()
  {
    //   this->setClassID(CL_PROTO_ID, "GLGuiEnergyWidget");
    this->pack(&this->_name);
    this->pack(&this->_valueText);
    this->pack(&this->_bar);

    this->setBackgroundTexture("maps/gui_element_background_2.png");
    this->setBackgroundColor(Color(.5,.5,.5,1));

    this->_name.setBackgroundTexture(Texture());
    this->_valueText.setBackgroundTexture("maps/gui_element_background_2.png");
    this->_valueText.setBackgroundTexture("maps/gui_element_background_2.png");
    this->_bar.setBackgroundTexture(Texture());
  }


  /**
   * @brief standard deconstructor
   */
  GLGuiEnergyWidget::~GLGuiEnergyWidget ()
  {
    // delete what has to be deleted here
  }


  void GLGuiEnergyWidget::setDisplayedName(const std::string& name)
  {
    this->_name.setText(name);
  }

  void GLGuiEnergyWidget::setMaximum(float max)
  {
    this->_bar.setMaximum(max);
  }

  void GLGuiEnergyWidget::setValue(float value)
  {
    MultiType val(value);
    val.setType(MT_INT);

    this->_bar.setValue(value);
    this->_valueText.setText(val.getString());
  }


  void GLGuiEnergyWidget::showing()
  {
    this->_name.show();
    this->_valueText.show();
    this->_bar.show();
  }

  void GLGuiEnergyWidget::hiding()
  {
    this->_name.hide();
    this->_valueText.hide();
    this->_bar.hide();
  }
}
